diff --git a/hcache/hcache.c b/hcache/hcache.c
index 9d5ded3df5..acc70714a8 100644
--- a/hcache/hcache.c
+++ b/hcache/hcache.c
@@ -339,7 +339,7 @@ static void restore_buffer(struct Buffer **b, const unsigned char *d, int *off,
 
   restore_char(&(*b)->data, d, off, convert);
   restore_int(&offset, d, off);
-  (*b)->dptr = (*b)->data + offset;
+  mutt_buffer_seek(*b, offset);
   restore_int(&used, d, off);
   (*b)->dsize = used;
   restore_int(&used, d, off);
diff --git a/imap/imap.c b/imap/imap.c
index 339f43bd7f..b1b1321e29 100644
--- a/imap/imap.c
+++ b/imap/imap.c
@@ -1296,7 +1296,7 @@ int imap_sync_message_for_copy(struct ImapData *idata, struct Header *hdr,
   }
 
   snprintf(uid, sizeof(uid), "%u", HEADER_DATA(hdr)->uid);
-  cmd->dptr = cmd->data;
+  mutt_buffer_rewind(cmd);
   mutt_buffer_addstr(cmd, "UID STORE ");
   mutt_buffer_addstr(cmd, uid);
 
diff --git a/imap/message.c b/imap/message.c
index e0beca36fa..a3fa520b54 100644
--- a/imap/message.c
+++ b/imap/message.c
@@ -560,7 +560,7 @@ static void generate_seqset(struct Buffer *b, struct ImapData *idata,
   /* Too big.  Just query the whole range then. */
   if (chunks == 150 || mutt_str_strlen(b->data) > 500)
   {
-    b->dptr = b->data;
+    mutt_buffer_rewind(b);
     mutt_buffer_printf(b, "%u:%u", msn_begin, msn_end);
   }
 }
diff --git a/init.c b/init.c
index 1a0fda6428..b3d3ce8eeb 100644
--- a/init.c
+++ b/init.c
@@ -544,7 +544,7 @@ int mutt_extract_token(struct Buffer *dest, struct Buffer *tok, int flags)
   char *pc = NULL;
 
   /* reset the destination pointer to the beginning of the buffer */
-  dest->dptr = dest->data;
+  mutt_buffer_rewind(dest);
 
   SKIPWS(tok->dptr);
   while ((ch = *tok->dptr))
diff --git a/mutt/buffer.c b/mutt/buffer.c
index 3eafd7470a..0f41c4bdc0 100644
--- a/mutt/buffer.c
+++ b/mutt/buffer.c
@@ -28,14 +28,16 @@
  *
  * | Function             | Description
  * | :------------------- | :--------------------------------------------------
+ * | mutt_buffer_init()   | Initialise a new Buffer
+ * | mutt_buffer_deinit() | Release the memory allocated by a Buffer
  * | mutt_buffer_add()    | Add a string to a Buffer, expanding it if necessary
  * | mutt_buffer_addch()  | Add a single character to a Buffer
  * | mutt_buffer_addstr() | Add a string to a Buffer
  * | mutt_buffer_from()   | Initialize a Buffer from an existing string
- * | mutt_buffer_init()   | Initialise a new Buffer
- * | mutt_buffer_deinit() | Release the memory allocated by a Buffer
  * | mutt_buffer_printf() | Format a string into a Buffer
  * | mutt_buffer_reset()  | Reset an existing Buffer
+ * | mutt_buffer_rewind() | Rewind the r/w position to the start of the Buffer
+ * | mutt_buffer_seek()   | Set the r/w position to a specific offset
  */
 
 #include "config.h"
@@ -52,18 +54,18 @@
  *
  * This must not be called on a Buffer that already contains data.
  */
-void mutt_buffer_init(struct Buffer *b)
+void mutt_buffer_init(struct Buffer *buf)
 {
-  memset(b, 0, sizeof(struct Buffer));
+  memset(buf, 0, sizeof(struct Buffer));
 }
 
 /**
  * mutt_buffer_deinit - Release the memory allocated by a Buffer
  * @param b Buffer to release
  */
-void mutt_buffer_deinit(struct Buffer *b)
+void mutt_buffer_deinit(struct Buffer *buf)
 {
-  FREE(&b->data);
+  FREE(&buf->data);
 }
 
 /**
@@ -73,10 +75,10 @@ void mutt_buffer_deinit(struct Buffer *b)
  * This can be called on a Buffer to reset the pointers,
  * effectively emptying it.
  */
-void mutt_buffer_reset(struct Buffer *b)
+void mutt_buffer_reset(struct Buffer *buf)
 {
-  memset(b->data, 0, b->dsize);
-  b->dptr = b->data;
+  memset(buf->data, 0, buf->dsize);
+  mutt_buffer_rewind(buf);
 }
 
 /**
@@ -92,7 +94,7 @@ void mutt_buffer_from(struct Buffer *buf, char *seed)
   mutt_buffer_init(buf);
   buf->data = mutt_str_strdup(seed);
   buf->dsize = mutt_str_strlen(seed);
-  buf->dptr = (char *) buf->data + buf->dsize;
+  mutt_buffer_seek(buf, buf->dsize);
 }
 
 /**
@@ -115,7 +117,7 @@ static void mutt_buffer_add(struct Buffer *buf, const char *s, size_t len)
     size_t offset = buf->dptr - buf->data;
     buf->dsize += (len < 128) ? 128 : len + 1;
     mutt_mem_realloc(&buf->data, buf->dsize);
-    buf->dptr = buf->data + offset;
+    mutt_buffer_seek(buf, offset);
   }
   if (!buf->dptr)
     return;
@@ -143,7 +145,7 @@ int mutt_buffer_printf(struct Buffer *buf, const char *fmt, ...)
   va_copy(ap_retry, ap);
 
   if (!buf->dptr)
-    buf->dptr = buf->data;
+    mutt_buffer_rewind(buf);
 
   doff = buf->dptr - buf->data;
   blen = buf->dsize - doff;
@@ -153,7 +155,7 @@ int mutt_buffer_printf(struct Buffer *buf, const char *fmt, ...)
     blen = 128;
     buf->dsize += blen;
     mutt_mem_realloc(&buf->data, buf->dsize);
-    buf->dptr = buf->data + doff;
+    mutt_buffer_seek(buf, doff);
   }
   len = vsnprintf(buf->dptr, blen, fmt, ap);
   if (len >= blen)
@@ -163,7 +165,7 @@ int mutt_buffer_printf(struct Buffer *buf, const char *fmt, ...)
       blen = 128;
     buf->dsize += blen;
     mutt_mem_realloc(&buf->data, buf->dsize);
-    buf->dptr = buf->data + doff;
+    mutt_buffer_seek(buf, doff);
     len = vsnprintf(buf->dptr, len, fmt, ap_retry);
   }
   if (len > 0)
@@ -198,3 +200,22 @@ void mutt_buffer_addch(struct Buffer *buf, char c)
 {
   mutt_buffer_add(buf, &c, 1);
 }
+
+/**
+ * mutt_buffer_rewind - Rewind the read/write position of the Buffer
+ * @param buf Buffer to rewind
+ */
+void mutt_buffer_rewind(struct Buffer *buf)
+{
+  mutt_buffer_seek(buf, 0);
+}
+
+/**
+ * mutt_buffer_seek - Set the read/write position to a specific offset
+ * @param buf Buffer to rewind
+ * @param off Offset
+ */
+void mutt_buffer_seek(struct Buffer *buf, size_t off)
+{
+  buf->dptr = buf->data + off;
+}
diff --git a/mutt/buffer.h b/mutt/buffer.h
index 6dcfe711a6..069150a196 100644
--- a/mutt/buffer.h
+++ b/mutt/buffer.h
@@ -39,12 +39,14 @@ struct Buffer
 
 #define MoreArgs(p) (*(p)->dptr && (*(p)->dptr != ';') && (*(p)->dptr != '#'))
 
+void mutt_buffer_init(struct Buffer *buf);
+void mutt_buffer_deinit(struct Buffer *buf);
 void mutt_buffer_addch(struct Buffer *buf, char c);
 void mutt_buffer_addstr(struct Buffer *buf, const char *s);
 void mutt_buffer_from(struct Buffer *buf, char *seed);
-void mutt_buffer_init(struct Buffer *buf);
-void mutt_buffer_deinit(struct Buffer *buf);
 int  mutt_buffer_printf(struct Buffer *buf, const char *fmt, ...);
 void mutt_buffer_reset(struct Buffer *buf);
+void mutt_buffer_rewind(struct Buffer *buf);
+void mutt_buffer_seek(struct Buffer *buf, size_t off);
 
 #endif /* _MUTT_BUFFER_H */
diff --git a/parse.c b/parse.c
index bd1542f786..4e8ea473a0 100644
--- a/parse.c
+++ b/parse.c
@@ -1223,8 +1223,7 @@ struct Envelope *mutt_read_rfc822_header(FILE *f, struct Header *hdr,
           /* else overwrite */
           else
           {
-            e->spam->dptr = e->spam->data;
-            *e->spam->dptr = '\0';
+            mutt_buffer_rewind(e->spam);
             mutt_buffer_addstr(e->spam, buf);
           }
         }
